		section	saveload
		public	cload, csave,data,stopkey

FCB: 		EQU	005Ch 		;Dateikontrollblock
DMA:		EQU	001BH		;ZEIGER AUF KASSETTENPUFFER
DATA		equ	0044h
INTLN:		equ	0100h		; interner Zeichenkettenpuffer


GVAL    	EQU	0F1EAh
OCRLF:		EQU	0F2FEH
OSPAC:		EQU	0F310H
GETMS   	EQU	0F35Ch
REA1		EQU	0F5A6h
COEXT   	EQU	0F5B9h
ERINP		EQU	0F5E2h
ERPAR   	EQU	0F5E6h
DECO0		equ	0FD33h		; DECODIEREN DER TASTATURMATRIX

;------------------------------------------------------------------------------
; LOAD/SAVE
;------------------------------------------------------------------------------
;

LOAD:	CALL	GVAL		;NAECHSTEN PARAMETER HOLEN
	RET	Z		;KEIN GUELTIGER NAME
;

;DATEI LADEN OHNE START
LOAD1:	call	prepfcb
	ret	c
LOAD4:
	;CALL	OPENR
	ld	c,13		;OPENR
	call	5
	JR	NC, LOAD5	;KEIN FEHLER
	OR	A
	SCF
	RET	Z		;STOP GEGEBEN
	CALL	REA1		;AUSG. FEHLERMELD. WARTEN REAKT.
	RET	C		;STOP GEGEBEN
	JR	LOAD4		;WIEDERHOLUNG
LOAD5:	ld	hl,(data)	;neue aadr?
	ld	a,h
	or	l
	jr	nz,LOAD51
	LD	HL,(FCB+17)	;DATEIANFANGSADRESSE
LOAD51:	LD	(DMA),HL	;NACH ADR. KASSETTENPUFFER
LOA55:
	;CALL	READ		;LESEN BLOCK
	ld	c,20		; READ
	call	5
	JR	NC, LOAD6	;KEIN FEHLER
	CALL	REA1		;AUSG. FEHLERMELD. WARTEN REAKT.
	RET	C		;STOP GEGEBEN
	XOR	A
LOAD6:	OR	A
	JR	Z, LOA55	;WEITER BIS DATEIENDE LESEN
	JP	OCRLF
;
MOV:	LD	HL,INTLN+1	;ZWISCHENPUFFER
	LD	B,A
MOV2:	LD	A,(HL)
	LD	(DE),A
	INC	HL
	INC	DE
	DJNZ	MOV2
	RET

prepfcb:
	LD	HL,ERPAR
	PUSH	HL
	LD	A,(INTLN)	;PARAMETERLAENGE
	CP	A, 9
	RET	NC		;NAME ZU LANG
	LD	DE,FCB
	LD	A,8
	CALL	MOV		;NAME IN FCB EINTRAGEN
	EX	AF, AF'
	JR	NC, LOAD3	;DATEITYP FOLGT
	EX	AF, AF'
	LD	HL,"XT"		;STANDARDEINTRAGUNG
	LD	(FCB+8),HL	;
	LD	A,'T'		;TXT VORNEHMEN
	LD	(FCB+10),A	;
	JR	LOA33
LOAD3:	LD	A,C
	CP	A, '.'
	POP	HL
	JP	NZ, ERINP	;FALSCHES TRENNZEICHEN
	PUSH	HL
	CALL	GVAL		;PARAMETER HOLEN
	RET	Z		;KEIN GUELTIGER TYP
	LD	A,3
	CP	A, B		;TYP IST ZU LANG
	RET	C
	LD	DE,FCB+8	;TYP IN FCB EINTRAGEN
	CALL	MOV
LOA33:	POP	HL
	EX	AF, AF'		;'
	JP	NC, ERINP	;ZU VIELE PARAMETER
	ccf
	ret

;CLOAD
;in:
;   A=0 => Dateiname+Typ ist bereits im FCB eingetragen
;   A=1 => Dateiname "Name[.Typ]" muss in CONBU abgelegt sein
;   A=2 => zuerst Abfrage "Filename:"
;   HL = 0 => orig. aadr wird genommen
;   HL <> 0 => aadr
;ret: Cy=1 Fehler
cload:		ld	(data),hl	; HL merken
		or	a
		jp	z, LOAD4	; A=0 -> Dateiname+Typ ist bereits im FCB eingetragen
		dec	a
		jr	z, cload1	; A=1 => Dateiname+Typ steht in CONBU

		call	getfname	; A=2 => Filename abfragen
		ret	c
cload1		jp	LOAD

;Filename abfragen, Eingabe als "Name[.Typ]"
getfname:	ld	de, aFilename	; Kassetten-I/O: Filename abfragen+laden/speichern
		ld	c,9
		call	5
		call	GETMS		; EINGABE ZEICHENKETTE IN MONITORPUFFER
		ret	c
		call	COEXT		; VORVERARBEITEN EINER ZEICHENKETTE
		ret
aFilename:	db "Filename: ",0


;CSAVE
;
csave: 		or	a
		jp	z, csave1	; A=0 -> Dateiname+Typ ist bereits im FCB eingetragen
		dec	a
		jr	z, csave4	; A=1 => Dateiname+Typ steht in CONBU
;
		call	getfname	; A=2 => Filename abfragen
		ret	c
;
csave4:		CALL	GVAL		;NAECHSTEN PARAMETER HOLEN
		RET	Z		;KEIN GUELTIGER NAME
		call	prepfcb
		ret	c
;
csave1		ld	hl, (fcb+19)	; EADR
		ld	de, (fcb+17)	; AADR
		or	a
		sbc	hl, de
		ret	c		; aadr > eadr
		ld	c, 15		;OPENW: Eroeffnen Kassette schreiben
		call	5
		ret	c
		call	ospac		; Ausgabe Leerzeichen
		call	stopkey		; Test auf <STOP>
		ret	c		; wenn STOP
		ex	de, hl
		ld	(DMA), hl
csave3:		ld	hl, (DMA)
		ld	de, 7Fh
		add	hl, de
		ld	de, (fcb+19)	; EADR
		sbc	hl, de
		jr	nc, csave2
		ld	c, 21		; WRITS: Schreiben eines Blockes auf Kassette
		call	5
		ret	c
		call	ospac		; Ausgabe Leerzeichen
		call	stopkey		; Test auf <STOP>
		ret	c		; wenn STOP
		jr	csave3
csave2:		ld	c, 16		; CLOSW: Abschlieen Kassette schreiben
		call	5
		ret	c
		JP	OCRLF
;


; Test,	ob <STOP> gedrckt -> Cy=1
stopkey:	call	DECO0		; DECODIEREN DER TASTATURMATRIX
		ei
		or	a
		ret	z
		cp	3		; <STOP> ?
		scf
		ret	z
		ccf
		ret

		endsection
